<script setup lang="ts">
    import { ListableItem } from '@/shared/item/entities/ListableItem'
    import { computed, ref } from 'vue'
    import { VListItem } from 'vuetify/lib/components/index.mjs'

    interface Props {
        item: ListableItem
        bookmarks?: ReturnType<ListableItem['getItemId']>[]
        bookmarkable?: boolean
        noImage?: boolean
        itemSelected?: ListableItem
    }

    const emit = defineEmits(['update:bookmarks', 'update:itemSelected'])

    const props = withDefaults(defineProps<Props>(), {
        noImage: false,
        itemSelected: undefined,
        bookmarkable: false,
        bookmarks: () => [],
    })

    const itemSelected = computed({
        get() {
            return props.itemSelected
        },
        set(item) {
            emit('update:itemSelected', item)
        },
    })

    const isBookmark = ref<boolean>(
        props.bookmarkable
            ? (props.bookmarks?.includes(props.item.getItemId()) ?? false)
            : false
    )

    function dropBookmark(
        bookmarks: ReturnType<ListableItem['getItemId']>[],
        droppedItem: ListableItem
    ): ReturnType<ListableItem['getItemId']>[] {
        return bookmarks.filter((item) => item !== droppedItem.getItemId())
    }

    function addBookmark(
        bookmarks: ReturnType<ListableItem['getItemId']>[],
        addedItem: ListableItem
    ) {
        return [addedItem.getItemId()].concat(props.bookmarks)
    }

    const listItemRef = ref<InstanceType<typeof VListItem> | null>(null) // doc : https://vuejs.org/guide/typescript/composition-api.html#typing-component-template-refs

    // watch(
    //     () => itemSelected.value,
    //     (selectedItem) => {
    //         if (selectedItem) {
    //             if (
    //                 listItemRef.value &&
    //                 props.item.getItemId() === itemSelected.value?.getItemId()
    //             ) {
    //                 listItemRef.value.$el.scrollIntoView({
    //                     behavior: 'smooth',
    //                 })
    //             }
    //         }
    //     }
    // )

    const itemHeight = ref<number>(78)
</script>

<template>
    <v-lazy :height="itemHeight">
        <v-list-item
            ref="listItemRef"
            :data-cy="`listItem-Component-${item.getItemId()}`"
            :active="item.getItemId() === itemSelected?.getItemId()"
            :style="{ height: `${itemHeight}px` }"
            @click="itemSelected = item"
        >
            <template #prepend>
                <v-avatar rounded size="50" class="float-left">
                    <v-icon
                        v-if="!item.getItemImageUrl()"
                        class="text-h3"
                        color="grey-lighten-2"
                        data-cy="no-image-icon"
                    >
                        mdi-camera-off-outline
                    </v-icon>
                    <v-img
                        v-else
                        :src="item.getItemImageUrl()?.href"
                        :alt="item.getItemTitle()"
                        cover
                        aspect-ratio="1"
                        data-cy="illustration"
                    >
                    </v-img>
                </v-avatar>
            </template>

            <div class="d-flex justify-space-between">
                <v-list-item-title
                    class="item-title text-subtitle-1"
                    data-cy="title"
                >
                    {{ item.getItemTitle() }}
                </v-list-item-title>
                <v-chip
                    v-for="itemChip in item.getItemChips()"
                    :key="itemChip.label"
                    data-cy="component-chip"
                    size="small"
                    variant="flat"
                    :color="itemChip.color"
                    class="text-capitalize mt-1 flex-shrink-0"
                >
                    {{ itemChip.label }}
                </v-chip>
            </div>
            <v-list-item-subtitle class="text-subtitle-2" data-cy="subtitle">
                {{ item.getItemDescription() }}
            </v-list-item-subtitle>
            <div class="d-flex">
                <span class="text-caption mr-3 ml-auto" data-cy="anteriority">{{
                    item.getItemTemporalData()
                }}</span>
            </div>
            <template v-if="bookmarkable" #append>
                <v-btn
                    v-if="isBookmark"
                    variant="text"
                    icon="mdi-star"
                    color="secondary"
                    data-cy="is-bookmarked"
                    @click.prevent="
                        $emit(
                            'update:bookmarks',
                            dropBookmark(bookmarks, item)
                        ),
                            (isBookmark = !isBookmark)
                    "
                ></v-btn>
                <v-btn
                    v-else
                    variant="text"
                    icon="mdi-star-outline"
                    color="disabled"
                    data-cy="is-not-bookmarked"
                    @click.prevent="
                        $emit('update:bookmarks', addBookmark(bookmarks, item)),
                            (isBookmark = !isBookmark)
                    "
                ></v-btn>
            </template>
        </v-list-item>
    </v-lazy>
</template>
